package lcsb.mapviewer.common.geometry;

import static org.junit.Assert.assertEquals;

import java.awt.*;

import org.junit.*;

import lcsb.mapviewer.common.CommonTestFunctions;
import lcsb.mapviewer.common.exception.InvalidArgumentException;

public class ColorParserTest extends CommonTestFunctions {

  @AfterClass
  public static void tearDownAfterClass() throws Exception {
  }

  @Before
  public void setUp() throws Exception {
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test(expected = InvalidArgumentException.class)
  public void testSetInvalidColor() throws Exception {
    ColorParser parser = new ColorParser();
    parser.parse("qwe");
  }

  @Test(expected = InvalidArgumentException.class)
  public void testSetInvalidColor2() throws Exception {
    ColorParser parser = new ColorParser();
    parser.parse("fffffff");
  }

  @Test
  public void testSetColor() throws Exception {
    ColorParser parser = new ColorParser();
    Color color = parser.parse("#ffffff");
    assertEquals(Color.WHITE, color);
  }

  @Test(expected = InvalidArgumentException.class)
  public void testParseNull() throws Exception {
    ColorParser parser = new ColorParser();
    parser.parse(null);
  }

  @Test(expected = InvalidArgumentException.class)
  public void testParseEmpty() throws Exception {
    ColorParser parser = new ColorParser();
    parser.parse("");
  }

  @Test
  public void testSetColorToHtmlString() throws Exception {
    ColorParser parser = new ColorParser();

    String colorString = "#ffffff";
    Color color = parser.parse(colorString);
    assertEquals(colorString, parser.colorToHtml(color));

    colorString = "#fc00ff";
    color = parser.parse(colorString);
    assertEquals(colorString, parser.colorToHtml(color));
  }

}
