package lcsb.mapviewer.converter.model.sbgnml;

import java.awt.*;
import java.io.File;
import java.nio.file.Files;

import org.junit.Rule;

import lcsb.mapviewer.common.UnitTestFailedWatcher;
import lcsb.mapviewer.converter.graphics.*;
import lcsb.mapviewer.model.map.model.Model;

public class SbgnmlTestFunctions {

  @Rule
  public UnitTestFailedWatcher unitTestFailedWatcher = new UnitTestFailedWatcher();

  protected void showImage(Model model) throws Exception {
    String dir = Files.createTempDirectory("sbml-temp-images-dir").toFile().getAbsolutePath();
    AbstractImageGenerator.Params params = new AbstractImageGenerator.Params().height(model.getHeight())
        .width(model.getWidth()).nested(true).scale(1).level(20).x(0).y(0).model(model);
    NormalImageGenerator nig = new PngImageGenerator(params);
    String pathWithouExtension = dir + "/" + model.getName();
    String pngFilePath = pathWithouExtension.concat(".png");
    nig.saveToFile(pngFilePath);
    Desktop.getDesktop().open(new File(pngFilePath));
  }
}
