package lcsb.mapviewer.model.map.species;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.SerializationUtils;
import org.junit.*;
import org.mockito.Mockito;

import lcsb.mapviewer.ModelTestFunctions;
import lcsb.mapviewer.common.exception.NotImplementedException;
import lcsb.mapviewer.model.map.species.field.ModificationResidue;
import lcsb.mapviewer.model.map.species.field.Residue;

public class ProteinTest extends ModelTestFunctions {

  @Before
  public void setUp() throws Exception {
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testSerialization() {
    SerializationUtils.serialize(new GenericProtein());
  }

  @Test
  public void testConstructor1() {
    GenericProtein protein = new GenericProtein();
    protein.setStructuralState("srt");
    List<ModificationResidue> residues = new ArrayList<>();
    residues.add(new Residue());

    protein.setModificationResidues(residues);
    Protein protein2 = new GenericProtein(protein);
    assertNotNull(protein2);
  }

  @Test
  public void testSetStructuralState() {
    GenericProtein protein = new GenericProtein();
    protein.setStructuralState("str");
    protein.setStructuralState("str1");

    assertEquals("str1", protein.getStructuralState());
  }

  @Test
  public void testGetters() {
    GenericProtein protein = new GenericProtein("id");
    assertNotNull(protein.getStringType());
  }

  @Test
  public void testCopy() {
    GenericProtein protein = new GenericProtein().copy();
    assertNotNull(protein);
  }

  @Test(expected = NotImplementedException.class)
  public void testInvalidCopy() {
    GenericProtein mock = Mockito.spy(GenericProtein.class);
    mock.copy();
  }

}
