package lcsb.mapviewer.web;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.delete;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.*;
import org.junit.runner.RunWith;
import org.springframework.http.MediaType;
import org.springframework.test.annotation.Rollback;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.web.servlet.RequestBuilder;

@RunWith(SpringJUnit4ClassRunner.class)
@Rollback
public class CommentControllerIntegrationTestWithoutTransaction extends ControllerIntegrationTest {

  private static final String BUILT_IN_TEST_ADMIN_PASSWORD = "admin";
  private static final String BUILT_IN_TEST_ADMIN_LOGIN = "admin";
  Logger logger = LogManager.getLogger();

  @Before
  public void setup() {
  }

  @After
  public void tearDown() {
  }

  @Test
  public void testRemoveNonExistingCommentOnNonExistingMap() throws Exception {
    RequestBuilder request = delete("/projects/*/comments/-1/")
        .contentType(MediaType.APPLICATION_FORM_URLENCODED);

    mockMvc.perform(request)
        .andExpect(status().is4xxClientError());
  }
}
